/* 15-213 Fall '98.  Assignment H1 */



#include "bits.h"


/* Fill in the following structure with your identifying information */

team_struct team =
{

   /* Replace with full name of first team member */
   "",
   /* Replace with Andrew ID of first team member */
   "",

   /* The following should only be changed if there are two team members */
   /* Replace with full name of second team member */
   "",
   /* Replace with Andrew ID of second team member */
   ""

};


/* Edit the following code to provide your solutions to Asst H1 */
/* To turn in:
   1. Rename completed file: bits-XXXX.c, where XXXX is the Andrew ID of
      the first team member
   2. Copy the file to the AFS directory designated in the assignment handout
*/

/****
 Coding Rules:
 
 Your code must conform to the following style:
 
 long int Funct(...) 
 {
    /* Informative comment about code line below * /
    long int var1 = Expr1;
    /* Informative comment about code line below * /
    long int var2 = Expr2;
    ...
    /* Informative comment about code line below * /
    long int varK = ExprK;
    /* Informative comment about code line below * /
    return ExprR;
 }
 
 Each "Expr" is an expression using only the following:
 1. Long integer constants 0L through 255L (0xFFL), inclusive.
 2. Unary long integer operations ! ~
 3. Casting from "int" to "long int" (either implicit or explicit.)
 4. Binary long integer operations & ^ | + << >>
 5. Call to one of the other functions in the file
    [Not recommended for performance reasons, but useful for debugging]
 6. Call to functions of the form test_PPP, where PPP is one of the functions
    in this file [Only if you could not get a correct solution to PPP]
    
Some of the problems restrict the set of allowed operators even further.

You are expressly forbidden to:
 1. Use any control constructs such as if, do, while, for, switch, etc.
 2. Define or use any macros
 3. Define any additional functions in this file
 4. Call any functions outside this file [other than ones of the form
    test_PPP, where PPP is one of the functions in this file, but you
    were unable to get it working.
 5. Use any other operations, such as &&, ||, -, or ?:
 6. Any use of explicit or implicit casting, other than from 
    "int" to "long int".
 
You may assume your machine:
 1. Uses 2's complement representations of integers
 2. Performs right shifts arithmetically
 3. Uses either a 32- or 64-bit representation of long integers
 4. Has unpredictable behavior when shifting a long integer by more
    than the word size
 
 If you cannot solve one of the problems:
 1. Do the best you can
 2. You may call the function test_PPP, where "PPP" is the name of the
    function you were trying to write, in other functions.
 3. You will be docked correctness points on this function, but not on others

****/

/****
   Part I:
   Bit-level operations
 ****/

/* x|y using only ~ and & */
long int bitOr(long int x, long int y)
{

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* x^y using only ~ and & */
long int bitXor(long int x, long int y)
{

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* x == 0L */
long int isZero(long int x) {

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* x == y */
long int isEqual(long int x, long int y)
{

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* Given mask y, are any masked bits of x set? */
long int anyMaskedBits(long int x, long int y)
{

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* Given mask y, are all masked bits of x set? */
long int allMaskedBits(long int x, long int y)
{

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/****
   Part II:
   Word Size Dependencies
****/

/* Is the machine word size <= 32? */
long int is32(void) {

  /* Replace the following line with code in the prescribed style */
  return 2L;

}

/* Where is the sign bit for this machine? */
long int signBit(void) {

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* Get most significant byte of x */
long int highByte(long int x) {

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/****
  Part III:
  Two's complement arithmetic
****/

/* Minimum two's complement integer */
long int TMin(void) {

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* -1L */
long int minusOne(void) {

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* Maximum two's complement integer */
long int TMax(void) {

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* x < 0L */
long int isNegative(long int x) {

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* x > 0L */
long int isPositive(long int x) {

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* -x */
long int negate(long int x) {

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* |x| (except returns TMin for TMin) */ 
long int absval(long int x)
{

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* x > y */
long int isGreater(long int x, long int y)
{

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

/* !X, using all of the other operations, but no function calls */
long int bang(long int x)
{

  /* Replace the following line with code in the prescribed style */ 
  return 2L;

}

